

%To plot normalized field strength, normalized power and 
%normalized power(dB) vs polar angle 'theta' for antennas

clc;

if ((size(data)~= [360,2])&(size(data)~= [72,2]));
    error('incorrect size of data array!');
end

[rows,columns]=size(data);
EdB = [data;data(1,1),data(1,2)];% first(0) and last(72 or 360)
                                 % values are the same
                                 
EdBnorm=(EdB(:,2)-max(EdB(:,2))+40)/40;
E3dB=(37/40)*ones((rows+1),1);

E = 10.^(EdB(:,2)/20);% actual field strength 
Enorm=E/max(E);% normalized field strength 
Ehp=(1/sqrt(2))*ones((rows+1),1);% half-power normalized 
                                 % field strength

Pnorm=Enorm.^2;% normalized radiated power
Php=(1/2)*ones((rows+1),1);% normalized radiated half-power

Theta=((0:360/rows:360)*2*pi/360).';

figure(1);
polar(Theta,EdBnorm,'green');
hold on;
polar(Theta,E3dB,'red');
title('2D Radiation Pattern: PdB vs theta');
hold off;

figure(2);
polar(Theta,Pnorm,'green');
hold on;
polar(Theta,Php,'red');
title('2D Radiation Pattern: P vs theta');
hold off;

figure(3);
polar(Theta,Enorm,'green');
hold on;
polar(Theta,Ehp,'red');
title('2D Radiation Pattern: E vs theta');
hold off;
