
%To plot directivity vs polar angle 'theta' for antennas

clc;

if ((size(data)~= [360,2])&(size(data)~= [72,2]));
    error('incorrect size of data array!');
end

[rows,columns]=size(data);
EdB = data(:,2);% field strength in dBuV/m
Theta = data(:,1);% polar angle in degrees
                                 
E = 10.^(EdB/20);% actual field strength uV/m 
Enorm=E/max(E);% normalized field strength 
Pnorm=Enorm.^2;% normalized radiated power

Thetazero=...
    input('Enter offset "Thetazero" degrees from polar plot : ');
Phi=Theta-Thetazero;% polar angle is now w.r.t. "Thetazero"
for i=1:rows;
if Phi(i)<0; Phi(i)=Phi(i)+360;
end;
end;% values of "Phi" are now all positive between 0 and 360 degrees

Psin=Pnorm.*abs(sin(Phi*pi/180));
Prad=pi*sum(Psin)*2*pi/rows;% 2*pi*(sum(Psin)/2)*2*pi/rows

Directivity=4*pi*Pnorm/Prad;
MaxDirectivity=4*pi/Prad;% since Pnormmax = 1
disp(['Maximum Directivity is ',num2str(MaxDirectivity),' or ',...
    num2str(10*log10(MaxDirectivity)),'dB']);

figure(1);
Rtheta=Theta*pi/180;% polar angle "Rtheta" is now in radians
plotarray=[Rtheta,Directivity];
plotarray = [plotarray;plotarray(1,1),plotarray(1,2)];
                                % first(0) and last(72 or 360)
                                % values are the same, for wrap around 
polar(plotarray(:,1),plotarray(:,2),'green');
view(90,-90);
title('2D Radiation Pattern: Directivity vs theta');

