
close all;
clc;

Nelem=10;
Mn=4;
d=1;
RodB=26;

M=1800;
theta=linspace(0,pi,M+1);
theta=theta';
dtheta=pi/M;

Ro=10^(RodB/20);
Zo=cosh(1/(Nelem-1)*acosh(Ro));

for i=1:Mn+1;
   Coef(i)=0;
   for j=i:Mn+1;
      if i==1,EN=2;
      else EN=1;
      end
      Coef(i)=Coef(i)+(-1)^(Mn-j+1)*Zo^(2*j-2)*factorial(j+Mn-2)*2*Mn/(EN*factorial(j-i)*factorial(j+i-2)*factorial(Mn-j+1));
   end
end

u=pi.*d.*cos(theta);
AF=0;
for i=1:Mn+1;
    AF=AF+Coef(i).*cos((2.*i-2).*u);
end

U=(abs(AF)./max(abs(AF))).^2;  
Prad=2*pi*sum(U.*sin(theta).*dtheta);  
D=4*pi*U/Prad; 
DdB=10.*log10(D+eps);
Do=max(D);
DodB=max(DdB);

disp(['Directivity = ',num2str(DodB),' dB']);
disp(['Directivity = ',num2str(Do),' dimensionless']);

AFdB=10.*log10(U+eps);

for i=1:M+1,
    if AFdB(i)<=-60,
        AFdB(i)=-60;
    end
end

AFdBnorm=(AFdB+60)/60;
thetafull=linspace(0,2*pi,2*M+1);
thetafull=thetafull';

rAFdBnorm=flipud(AFdBnorm(2:M,1));
AFdBfull=[AFdBnorm;rAFdBnorm;AFdBnorm(1)];

AF3dB=-3*ones((M+1),1);
AF3dBfull=((60-3)/60)*ones((2*M+1),1);

%Polar plot

figure(1);
polar(thetafull,AFdBfull,'green');
hold on;
polar(thetafull,AF3dBfull,'red');
title(['Polar 2D Array factorialor, DT Array , 9 elements, 0.25',...
       '\lambda,',' 26dB']);
view(90,-90);
hold off;
disp(['Polar 2D Array factorialor, DT Array, 9 elements, 0.25 ',...
       'lambda,',' 26dB']);
   
%Cartesian plot

figure(2);
plot(theta.*180/pi,AFdB,'green',theta.*180/pi,AF3dB,'red');
axis([0 180 -60 1]);
xlabel(['\theta',' (degrees)']),ylabel('Normalized Array factorialor (dB)');
title(['Cartesian 2D Array factorialor, DT Array, 9 elements, 0.25',...
       '\lambda,',' 26dB']);
disp(['Cartesian 2D Array factorialor, DT Array, 9 elements, 0.25 ',...
       'lambda,',' 26dB']);
   